%global pkg ps3stor
%global kernel 5.10.134-18.an8
%define pkg_version 2.3.1.24
%define anolis_release 1

%define kmod_name		%{pkg}
%define kmod_driver_version     %{pkg_version}
%define kmod_rpm_release	%{anolis_release}
%define kmod_kernel_version	%{kernel}
%define kmod_kernel_version_dep	%{kmod_kernel_version}
%define kmod_install_path	extra/ps3stor
%global kernel_source() 	/usr/src/kernels/%{kmod_kernel_version}.%{_arch}
%define __find_requires 	/usr/lib/rpm/redhat/find-requires.ksyms
%define __find_provides 	/usr/lib/rpm/redhat/find-provides.ksyms %{kmod_name} %{?epoch:%{epoch}:}%{version}-%{release}
%define sbindir 		%( if [ -d "/sbin" -a \! -h "/sbin" ]; then echo "/sbin"; else echo %{_sbindir}; fi )
%define dup_state_dir 		%{_localstatedir}/lib/rpm-state/kmod-dups
%define kver_state_dir 		%{dup_state_dir}/kver
%define kver_state_file 	%{kver_state_dir}/%{kmod_kernel_version}.%{_arch}
%define dup_module_list 	%{dup_state_dir}/rpm-kmod-%{kmod_name}-modules
%define kernel_version	    	%{kernel}

Name:			kmod-ps3stor
Version:		%(echo %{kernel} | sed -E 's/-/~/g; s/\.(an|al)[0-9]+$//g')
Release:		%{pkg_version}~%{anolis_release}%{?dist}
Summary:		%{kmod_name} kernel module(s)
Group:			System/Kernel
License:		GPLv2
Distribution:		LinkData Corporation
Source0:		kmod-%{kmod_name}-%{kmod_driver_version}.tar.gz
BuildRoot:		%(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)
Provides:		kmod-%{kmod_name} = %{?epoch:%{epoch}:}%{version}-%{release}
Requires(post):		%{sbindir}/weak-modules
Requires(post):		%{sbindir}/depmod 
Requires(postun):       %{sbindir}/depmod 
Requires(postun):	%{sbindir}/weak-modules
Requires:		kernel-headers >= %{kernel_version}
Requires:		kernel >= %{kernel_version}
Requires:		kmod

BuildRequires:		kernel-headers = %{kernel_version}
BuildRequires:		kernel-devel = %{kernel_version}
ExclusiveArch: x86_64

%description
ps3stor drivers
This package provides the ps3stor kernel modules built for
the Linux kernel %{kmod_kernel_version} for the x86_64
family of processors.

%post
if [ -e "/boot/System.map-%{kmod_kernel_version}.%{_arch}" ]; then
	%{sbindir}/depmod -aeF "/boot/System.map-%{kmod_kernel_version}.%{_arch}" "%{kmod_kernel_version}.%{_arch}" > /dev/null || :
fi
depmod -a  %{kernel}.%{_arch} > /dev/null 2>&1
modules=( $(find /lib/modules/%{kmod_kernel_version}.%{_arch}/extra/ps3stor | grep '\.ko$') )
printf '%s\n' "${modules[@]}" | %{sbindir}/weak-modules --no-initramfs --add-modules

mkdir -p "%{kver_state_dir}"
touch "%{kver_state_file}"
if [ -e "/boot/initramfs-`uname -r`.img" ]; then  dracut -f > /dev/null 2>&1 ;fi
%preun
mkdir -p "%{dup_state_dir}"
rpm -ql kmod-ps3stor-%{kmod_driver_version}-%{kmod_rpm_release}.%(arch) | \
	grep '\.ko$' > "%{dup_module_list}"

%postun
if [ -e "/boot/System.map-%{kmod_kernel_version}.%{_arch}" ]; then
	%{sbindir}/depmod -aeF "/boot/System.map-%{kmod_kernel_version}.%{_arch}" "%{kmod_kernel_version}.%{_arch}" > /dev/null || :
fi
modules=( $(cat "%{dup_module_list}") )
rm -f "%{dup_module_list}"
printf '%s\n' "${modules[@]}" | %{sbindir}/weak-modules --no-initramfs --remove-modules

rmdir "%{dup_state_dir}" 2> /dev/null

exit 0
if [ -e "/boot/initramfs-`uname -r`.img" ]; then  dracut -f > /dev/null 2>&1 ;fi

%files
%defattr(644,root,root,755)
/lib/modules/%{kmod_kernel_version}.%{_arch}
/etc/depmod.d/%{kmod_name}.conf

%prep
%setup -n kmod-%{kmod_name}-%{kmod_driver_version}
set -- *
mkdir source
mv "$@" source/
mkdir obj

%build
rm -rf obj
cp -r source/src obj
make -C %{kernel_source} M=$PWD/obj

# mark modules executable so that strip-to-file can strip them
find obj -name "*.ko" -type f -exec chmod u+x '{}' +
whitelist="/lib/modules/kabi-current/kabi_whitelist_%{_target_cpu}"

%install
export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
export INSTALL_MOD_DIR=extra/ps3stor
make -C %{kernel_source} modules_install M=$PWD/obj
# Cleanup unnecessary kernel-generated module dependency files.
find $INSTALL_MOD_PATH/lib/modules -iname 'modules.*' -exec rm {} \;

#sed -e s/this_weakupdate-/`uname -r | cut -f1 -d-`/ \
kernel_ver=%{kmod_kernel_version}.%{_arch}
if [ ! -d $INSTALL_MOD_PATH/lib/modules/$kernel_ver ]; then
	[ -f /usr/src/kernels/$kernel_ver/include/config/kernel.release ] || exit 1
	kernel_config_ver=`cat /usr/src/kernels/$kernel_ver/include/config/kernel.release`
	[ -d $INSTALL_MOD_PATH/lib/modules/$kernel_config_ver ] || exit 1
	mv $INSTALL_MOD_PATH/lib/modules/$kernel_config_ver $INSTALL_MOD_PATH/lib/modules/$kernel_ver
fi

%{__install} -d  %{buildroot}%{_sysconfdir}/depmod.d
for kmod in $(find %{buildroot}/lib/modules/%{kernel}.%{_arch}/extra -type f -name \*.ko -printf "%%P\n" | sort)
do
echo "override $(basename $kmod .ko) * weak-updates/$(dirname $kmod)" >> %{buildroot}%{_sysconfdir}/depmod.d/%{kmod_name}.conf
echo "override $(basename $kmod .ko) * extra/$(dirname $kmod)" >> %{buildroot}%{_sysconfdir}/depmod.d/%{kmod_name}.conf
done

%clean
rm -rf $RPM_BUILD_ROOT

%changelog
